Index: /trunk/kBuild/tools/GCC.kmk
===================================================================
--- /trunk/kBuild/tools/GCC.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GCC.kmk	(revision 2545)
@@ -206,7 +206,4 @@
 	$(QUIET)$(TOOL_GCC_LD) $(flags) -o $(out) $(objs) \
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GCC.)
-endif
 endef
 
@@ -231,7 +228,4 @@
 	$(QUIET)$(TOOL_GCC_LD) $(TOOL_GCC_LDFLAGS.dll) $(flags) -o $(out) $(objs) \
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GCC.)
-endif
-endef
-
+endef
+
Index: /trunk/kBuild/tools/GCC3OMF.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3OMF.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GCC3OMF.kmk	(revision 2545)
@@ -253,7 +253,4 @@
 		-Zmap=$(outbase).map
 	$(QUIET)$(TOOL_GCC3OMF_LD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GCC3OMF.)
-endif
 endef
 
@@ -287,7 +284,4 @@
 		-Zmap=$(outbase).map
 	$(TOOL_GCC3OMF_LD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GCC3OMF.)
-endif
 endef
 
@@ -321,7 +315,4 @@
 		-Zmap=$(outbase).map
 	$(QUIET)$(TOOL_GCC3OMF_LD_SYSMOD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GCC3OMF.)
-endif
-endef
-
+endef
+
Index: /trunk/kBuild/tools/GCC3PLAIN.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 2545)
@@ -258,7 +258,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GCC3PLAIN.)
-endif
 endef
 
@@ -289,7 +286,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GCC3PLAIN.)
-endif
 endef
 
@@ -323,7 +317,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GCC3PLAIN.)
-endif
-endef
-
+endef
+
Index: /trunk/kBuild/tools/GXX.kmk
===================================================================
--- /trunk/kBuild/tools/GXX.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GXX.kmk	(revision 2545)
@@ -206,7 +206,4 @@
 	$(QUIET)$(TOOL_GXX_LD) $(flags) -o $(out) $(objs) \
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GXX.)
-endif
 endef
 
@@ -231,7 +228,4 @@
 	$(QUIET)$(TOOL_GXX_LD) $(TOOL_GXX_LDFLAGS.dll) $(flags) -o $(out) $(objs) \
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GXX.)
-endif
-endef
-
+endef
+
Index: /trunk/kBuild/tools/GXX3OMF.kmk
===================================================================
--- /trunk/kBuild/tools/GXX3OMF.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GXX3OMF.kmk	(revision 2545)
@@ -253,7 +253,4 @@
 		-Zmap=$(outbase).map
 	$(QUIET)$(TOOL_GXX3OMF_LD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GXX3OMF.)
-endif
 endef
 
@@ -287,7 +284,4 @@
 		-Zmap=$(outbase).map
 	$(TOOL_GXX3OMF_LD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GXX3OMF.)
-endif
 endef
 
@@ -321,7 +315,4 @@
 		-Zmap=$(outbase).map
 	$(QUIET)$(TOOL_GXX3OMF_LD_SYSMOD) @$(outbase).rsp
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requrested for $(target), but this feature is not supported by GXX3OMF.)
-endif
-endef
-
+endef
+
Index: /trunk/kBuild/tools/GXX3PLAIN.kmk
===================================================================
--- /trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 2544)
+++ /trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 2545)
@@ -258,7 +258,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GXX3PLAIN.)
-endif
 endef
 
@@ -289,7 +286,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GXX3PLAIN.)
-endif
 endef
 
@@ -323,7 +317,4 @@
 		$(foreach p,$(libpath), -L$(p))\
 		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
-if1of ($(ld_debug), split)
- $(warning kBuild: Debug splitting is requested for $(target), but this feature is not supported by GXX3PLAIN.)
-endif
-endef
-
+endef
+